// $ANTLR 2.7.3 (20041110-1): "lfp_parser.g" -> "LfP_Parser.java"$

import antlr.TokenBuffer;
import antlr.TokenStreamException;
import antlr.TokenStreamIOException;
import antlr.ANTLRException;
import antlr.LLkParser;
import antlr.Token;
import antlr.TokenStream;
import antlr.RecognitionException;
import antlr.NoViableAltException;
import antlr.MismatchedTokenException;
import antlr.SemanticException;
import antlr.ParserSharedInputState;
import antlr.collections.impl.BitSet;
import antlr.collections.AST;
import java.util.Hashtable;
import antlr.ASTFactory;
import antlr.ASTPair;
import antlr.collections.impl.ASTArray;

public class LfP_Parser extends antlr.LLkParser       implements LfPTokenTypes
 {

protected LfP_Parser(TokenBuffer tokenBuf, int k) {
  super(tokenBuf,k);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

public LfP_Parser(TokenBuffer tokenBuf) {
  this(tokenBuf,3);
}

protected LfP_Parser(TokenStream lexer, int k) {
  super(lexer,k);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

public LfP_Parser(TokenStream lexer) {
  this(lexer,3);
}

public LfP_Parser(ParserSharedInputState state) {
  super(state,3);
  tokenNames = _tokenNames;
  buildTokenTypeASTClassMap();
  astFactory = new ASTFactory(getTokenTypeToASTClassMap());
}

	public final void lfp() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST lfp_AST = null;
		AST m_AST = null;
		
		try {      // for error handling
			lfp_model();
			m_AST = (AST)returnAST;
			if ( inputState.guessing==0 ) {
				lfp_AST = (AST)currentAST.root;
				lfp_AST=(AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(ROOT,"ROOT")).add(m_AST));
				currentAST.root = lfp_AST;
				currentAST.child = lfp_AST!=null &&lfp_AST.getFirstChild()!=null ?
					lfp_AST.getFirstChild() : lfp_AST;
				currentAST.advanceChildToEnd();
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_0);
			} else {
			  throw ex;
			}
		}
		returnAST = lfp_AST;
	}
	
	public final void lfp_model() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST lfp_model_AST = null;
		
		try {      // for error handling
			{
			int _cnt13=0;
			_loop13:
			do {
				switch ( LA(1)) {
				case TYPE:
				{
					type();
					astFactory.addASTChild(currentAST, returnAST);
					break;
				}
				case CONST:
				{
					constant();
					astFactory.addASTChild(currentAST, returnAST);
					break;
				}
				case CLASS:
				{
					class_declaration();
					astFactory.addASTChild(currentAST, returnAST);
					break;
				}
				case BINDER:
				case STATIC:
				{
					binder_declaration();
					astFactory.addASTChild(currentAST, returnAST);
					break;
				}
				default:
					boolean synPredMatched8 = false;
					if (((LA(1)==IDENTIFIER) && (LA(2)==COMA||LA(2)==COLON) && (LA(3)==IDENTIFIER))) {
						int _m8 = mark();
						synPredMatched8 = true;
						inputState.guessing++;
						try {
							{
							match(IDENTIFIER);
							{
							_loop6:
							do {
								if ((LA(1)==COMA)) {
									match(COMA);
									match(IDENTIFIER);
								}
								else {
									break _loop6;
								}
								
							} while (true);
							}
							match(COLON);
							match(IDENTIFIER);
							{
							switch ( LA(1)) {
							case SEMI_COLON:
							{
								match(SEMI_COLON);
								break;
							}
							case AFFECT:
							{
								match(AFFECT);
								break;
							}
							default:
							{
								throw new NoViableAltException(LT(1), getFilename());
							}
							}
							}
							}
						}
						catch (RecognitionException pe) {
							synPredMatched8 = false;
						}
						rewind(_m8);
						inputState.guessing--;
					}
					if ( synPredMatched8 ) {
						variable();
						astFactory.addASTChild(currentAST, returnAST);
					}
					else {
						boolean synPredMatched12 = false;
						if (((LA(1)==IDENTIFIER) && (LA(2)==COMA||LA(2)==COLON) && (LA(3)==IDENTIFIER))) {
							int _m12 = mark();
							synPredMatched12 = true;
							inputState.guessing++;
							try {
								{
								match(IDENTIFIER);
								{
								_loop11:
								do {
									if ((LA(1)==COMA)) {
										match(COMA);
										match(IDENTIFIER);
									}
									else {
										break _loop11;
									}
									
								} while (true);
								}
								match(COLON);
								match(IDENTIFIER);
								match(WITH);
								}
							}
							catch (RecognitionException pe) {
								synPredMatched12 = false;
							}
							rewind(_m12);
							inputState.guessing--;
						}
						if ( synPredMatched12 ) {
							static_instance();
							astFactory.addASTChild(currentAST, returnAST);
						}
						else if ((LA(1)==MEDIA) && (LA(2)==IDENTIFIER) && (LA(3)==IS||LA(3)==SEMI_COLON)) {
							media_declaration();
							astFactory.addASTChild(currentAST, returnAST);
						}
						else if ((LA(1)==MEDIA) && (LA(2)==IDENTIFIER) && (LA(3)==OPEN_PAR)) {
							link_declaration();
							astFactory.addASTChild(currentAST, returnAST);
						}
					else {
						if ( _cnt13>=1 ) { break _loop13; } else {throw new NoViableAltException(LT(1), getFilename());}
					}
					}}
					_cnt13++;
				} while (true);
				}
				lfp_model_AST = (AST)currentAST.root;
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					consume();
					consumeUntil(_tokenSet_0);
				} else {
				  throw ex;
				}
			}
			returnAST = lfp_model_AST;
		}
		
	public final void type() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST type_AST = null;
		
		try {      // for error handling
			AST tmp1_AST = null;
			tmp1_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp1_AST);
			match(TYPE);
			AST tmp2_AST = null;
			tmp2_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp2_AST);
			match(IDENTIFIER);
			match(IS);
			type_declaration();
			astFactory.addASTChild(currentAST, returnAST);
			match(SEMI_COLON);
			type_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_1);
			} else {
			  throw ex;
			}
		}
		returnAST = type_AST;
	}
	
	public final void variable() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST variable_AST = null;
		
		try {      // for error handling
			AST tmp5_AST = null;
			tmp5_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp5_AST);
			match(IDENTIFIER);
			{
			_loop59:
			do {
				if ((LA(1)==COMA)) {
					match(COMA);
					AST tmp7_AST = null;
					tmp7_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp7_AST);
					match(IDENTIFIER);
				}
				else {
					break _loop59;
				}
				
			} while (true);
			}
			AST tmp8_AST = null;
			tmp8_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp8_AST);
			match(COLON);
			AST tmp9_AST = null;
			tmp9_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp9_AST);
			match(IDENTIFIER);
			{
			switch ( LA(1)) {
			case AFFECT:
			{
				AST tmp10_AST = null;
				tmp10_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp10_AST);
				match(AFFECT);
				expression();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case SEMI_COLON:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(SEMI_COLON);
			if ( inputState.guessing==0 ) {
				variable_AST = (AST)currentAST.root;
				variable_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(VARIABLE,"VARIABLE")).add(variable_AST));
				currentAST.root = variable_AST;
				currentAST.child = variable_AST!=null &&variable_AST.getFirstChild()!=null ?
					variable_AST.getFirstChild() : variable_AST;
				currentAST.advanceChildToEnd();
			}
			variable_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_1);
			} else {
			  throw ex;
			}
		}
		returnAST = variable_AST;
	}
	
	public final void static_instance() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST static_instance_AST = null;
		
		try {      // for error handling
			AST tmp12_AST = null;
			tmp12_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp12_AST);
			match(IDENTIFIER);
			{
			_loop21:
			do {
				if ((LA(1)==COMA)) {
					AST tmp13_AST = null;
					tmp13_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp13_AST);
					match(COMA);
					AST tmp14_AST = null;
					tmp14_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp14_AST);
					match(IDENTIFIER);
				}
				else {
					break _loop21;
				}
				
			} while (true);
			}
			AST tmp15_AST = null;
			tmp15_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp15_AST);
			match(COLON);
			AST tmp16_AST = null;
			tmp16_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp16_AST);
			match(IDENTIFIER);
			AST tmp17_AST = null;
			tmp17_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp17_AST);
			match(WITH);
			AST tmp18_AST = null;
			tmp18_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp18_AST);
			match(OPEN_PAR);
			{
			_loop23:
			do {
				if ((LA(1)==IDENTIFIER)) {
					agregate_element();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop23;
				}
				
			} while (true);
			}
			AST tmp19_AST = null;
			tmp19_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp19_AST);
			match(CLOSE_PAR);
			match(SEMI_COLON);
			static_instance_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_2);
			} else {
			  throw ex;
			}
		}
		returnAST = static_instance_AST;
	}
	
	public final void constant() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST constant_AST = null;
		Token  n = null;
		AST n_AST = null;
		Token  t = null;
		AST t_AST = null;
		Token  a = null;
		AST a_AST = null;
		AST e_AST = null;
		
		try {      // for error handling
			AST tmp21_AST = null;
			tmp21_AST = astFactory.create(LT(1));
			match(CONST);
			n = LT(1);
			n_AST = astFactory.create(n);
			match(IDENTIFIER);
			match(COLON);
			t = LT(1);
			t_AST = astFactory.create(t);
			match(IDENTIFIER);
			a = LT(1);
			a_AST = astFactory.create(a);
			match(AFFECT);
			expression();
			e_AST = (AST)returnAST;
			AST tmp23_AST = null;
			tmp23_AST = astFactory.create(LT(1));
			match(SEMI_COLON);
			if ( inputState.guessing==0 ) {
				constant_AST = (AST)currentAST.root;
				constant_AST = (AST)astFactory.make( (new ASTArray(3)).add(tmp21_AST).add(n_AST).add((AST)astFactory.make( (new ASTArray(3)).add(a_AST).add(t_AST).add(e_AST))));
				currentAST.root = constant_AST;
				currentAST.child = constant_AST!=null &&constant_AST.getFirstChild()!=null ?
					constant_AST.getFirstChild() : constant_AST;
				currentAST.advanceChildToEnd();
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_1);
			} else {
			  throw ex;
			}
		}
		returnAST = constant_AST;
	}
	
	public final void media_declaration() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST media_declaration_AST = null;
		
		try {      // for error handling
			AST tmp24_AST = null;
			tmp24_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp24_AST);
			match(MEDIA);
			AST tmp25_AST = null;
			tmp25_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp25_AST);
			match(IDENTIFIER);
			{
			switch ( LA(1)) {
			case IS:
			{
				match(IS);
				{
				_loop17:
				do {
					if ((_tokenSet_3.member(LA(1)))) {
						media_attribute();
						astFactory.addASTChild(currentAST, returnAST);
					}
					else {
						break _loop17;
					}
					
				} while (true);
				}
				{
				switch ( LA(1)) {
				case END:
				{
					match(END);
					break;
				}
				case BEGIN:
				{
					body();
					astFactory.addASTChild(currentAST, returnAST);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				break;
			}
			case SEMI_COLON:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(SEMI_COLON);
			media_declaration_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_2);
			} else {
			  throw ex;
			}
		}
		returnAST = media_declaration_AST;
	}
	
	public final void class_declaration() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST class_declaration_AST = null;
		
		try {      // for error handling
			AST tmp29_AST = null;
			tmp29_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp29_AST);
			match(CLASS);
			AST tmp30_AST = null;
			tmp30_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp30_AST);
			match(IDENTIFIER);
			{
			switch ( LA(1)) {
			case IS:
			{
				match(IS);
				{
				_loop27:
				do {
					if ((_tokenSet_4.member(LA(1)))) {
						attribute();
						astFactory.addASTChild(currentAST, returnAST);
					}
					else {
						break _loop27;
					}
					
				} while (true);
				}
				{
				switch ( LA(1)) {
				case END:
				{
					match(END);
					break;
				}
				case BEGIN:
				{
					body();
					astFactory.addASTChild(currentAST, returnAST);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				break;
			}
			case SEMI_COLON:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(SEMI_COLON);
			class_declaration_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_2);
			} else {
			  throw ex;
			}
		}
		returnAST = class_declaration_AST;
	}
	
	public final void binder_declaration() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST binder_declaration_AST = null;
		Token  f = null;
		AST f_AST = null;
		Token  s = null;
		AST s_AST = null;
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case STATIC:
			{
				AST tmp34_AST = null;
				tmp34_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp34_AST);
				match(STATIC);
				break;
			}
			case BINDER:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			AST tmp35_AST = null;
			tmp35_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp35_AST);
			match(BINDER);
			f = LT(1);
			f_AST = astFactory.create(f);
			astFactory.addASTChild(currentAST, f_AST);
			match(IDENTIFIER);
			AST tmp36_AST = null;
			tmp36_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp36_AST);
			match(DOT);
			s = LT(1);
			s_AST = astFactory.create(s);
			astFactory.addASTChild(currentAST, s_AST);
			match(IDENTIFIER);
			AST tmp37_AST = null;
			tmp37_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp37_AST);
			match(IS);
			{
			switch ( LA(1)) {
			case FIFO:
			{
				AST tmp38_AST = null;
				tmp38_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp38_AST);
				match(FIFO);
				break;
			}
			case BAG:
			{
				AST tmp39_AST = null;
				tmp39_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp39_AST);
				match(BAG);
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			AST tmp40_AST = null;
			tmp40_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp40_AST);
			match(OPEN_PAR);
			expression();
			astFactory.addASTChild(currentAST, returnAST);
			AST tmp41_AST = null;
			tmp41_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp41_AST);
			match(CLOSE_PAR);
			readers();
			astFactory.addASTChild(currentAST, returnAST);
			writers();
			astFactory.addASTChild(currentAST, returnAST);
			match(END);
			match(SEMI_COLON);
			binder_declaration_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_2);
			} else {
			  throw ex;
			}
		}
		returnAST = binder_declaration_AST;
	}
	
	public final void link_declaration() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST link_declaration_AST = null;
		
		try {      // for error handling
			AST tmp44_AST = null;
			tmp44_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp44_AST);
			match(MEDIA);
			AST tmp45_AST = null;
			tmp45_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp45_AST);
			match(IDENTIFIER);
			{
			if ((LA(1)==OPEN_PAR) && (LA(2)==IDENTIFIER)) {
				linked_components();
				astFactory.addASTChild(currentAST, returnAST);
			}
			else if ((LA(1)==OPEN_PAR) && (LA(2)==OPEN_PAR)) {
				list_of_list();
				astFactory.addASTChild(currentAST, returnAST);
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
			}
			match(SEMI_COLON);
			link_declaration_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_2);
			} else {
			  throw ex;
			}
		}
		returnAST = link_declaration_AST;
	}
	
	public final void media_attribute() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST media_attribute_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case TYPE:
			{
				type();
				astFactory.addASTChild(currentAST, returnAST);
				media_attribute_AST = (AST)currentAST.root;
				break;
			}
			case IDENTIFIER:
			{
				variable();
				astFactory.addASTChild(currentAST, returnAST);
				media_attribute_AST = (AST)currentAST.root;
				break;
			}
			case CONST:
			{
				constant();
				astFactory.addASTChild(currentAST, returnAST);
				media_attribute_AST = (AST)currentAST.root;
				break;
			}
			case TRIGGER:
			{
				trigger();
				astFactory.addASTChild(currentAST, returnAST);
				media_attribute_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_5);
			} else {
			  throw ex;
			}
		}
		returnAST = media_attribute_AST;
	}
	
	public final void body() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST body_AST = null;
		
		try {      // for error handling
			AST tmp47_AST = null;
			tmp47_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp47_AST);
			match(BEGIN);
			{
			int _cnt35=0;
			_loop35:
			do {
				if ((_tokenSet_6.member(LA(1)))) {
					statement();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					if ( _cnt35>=1 ) { break _loop35; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt35++;
			} while (true);
			}
			match(END);
			body_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_7);
			} else {
			  throw ex;
			}
		}
		returnAST = body_AST;
	}
	
	public final void agregate_element() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST agregate_element_AST = null;
		
		try {      // for error handling
			AST tmp49_AST = null;
			tmp49_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp49_AST);
			match(IDENTIFIER);
			AST tmp50_AST = null;
			tmp50_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp50_AST);
			match(IMPLIES);
			expression();
			astFactory.addASTChild(currentAST, returnAST);
			agregate_element_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_8);
			} else {
			  throw ex;
			}
		}
		returnAST = agregate_element_AST;
	}
	
	public final void attribute() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST attribute_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case TYPE:
			{
				type();
				astFactory.addASTChild(currentAST, returnAST);
				attribute_AST = (AST)currentAST.root;
				break;
			}
			case IDENTIFIER:
			{
				variable();
				astFactory.addASTChild(currentAST, returnAST);
				attribute_AST = (AST)currentAST.root;
				break;
			}
			case CONST:
			{
				constant();
				astFactory.addASTChild(currentAST, returnAST);
				attribute_AST = (AST)currentAST.root;
				break;
			}
			case ASYNCHRONOUS:
			case FUNCTION:
			case PROCEDURE:
			case SYNCHRONOUS:
			{
				methode();
				astFactory.addASTChild(currentAST, returnAST);
				attribute_AST = (AST)currentAST.root;
				break;
			}
			case TRIGGER:
			{
				trigger();
				astFactory.addASTChild(currentAST, returnAST);
				attribute_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_9);
			} else {
			  throw ex;
			}
		}
		returnAST = attribute_AST;
	}
	
	public final void methode() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST methode_AST = null;
		
		try {      // for error handling
			boolean synPredMatched69 = false;
			if (((LA(1)==FUNCTION||LA(1)==SYNCHRONOUS) && (LA(2)==FUNCTION||LA(2)==IDENTIFIER) && (LA(3)==IDENTIFIER||LA(3)==OPEN_PAR))) {
				int _m69 = mark();
				synPredMatched69 = true;
				inputState.guessing++;
				try {
					{
					match(SYNCHRONOUS);
					match(FUNCTION);
					}
				}
				catch (RecognitionException pe) {
					synPredMatched69 = false;
				}
				rewind(_m69);
				inputState.guessing--;
			}
			if ( synPredMatched69 ) {
				function();
				astFactory.addASTChild(currentAST, returnAST);
				methode_AST = (AST)currentAST.root;
			}
			else {
				boolean synPredMatched71 = false;
				if (((LA(1)==FUNCTION||LA(1)==SYNCHRONOUS) && (LA(2)==FUNCTION||LA(2)==IDENTIFIER) && (LA(3)==IDENTIFIER||LA(3)==OPEN_PAR))) {
					int _m71 = mark();
					synPredMatched71 = true;
					inputState.guessing++;
					try {
						{
						match(FUNCTION);
						}
					}
					catch (RecognitionException pe) {
						synPredMatched71 = false;
					}
					rewind(_m71);
					inputState.guessing--;
				}
				if ( synPredMatched71 ) {
					function();
					astFactory.addASTChild(currentAST, returnAST);
					methode_AST = (AST)currentAST.root;
				}
				else if ((LA(1)==ASYNCHRONOUS||LA(1)==PROCEDURE||LA(1)==SYNCHRONOUS) && (LA(2)==PROCEDURE||LA(2)==IDENTIFIER) && (LA(3)==IDENTIFIER||LA(3)==OPEN_PAR)) {
					procedure();
					astFactory.addASTChild(currentAST, returnAST);
					methode_AST = (AST)currentAST.root;
				}
				else {
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
			}
			catch (RecognitionException ex) {
				if (inputState.guessing==0) {
					reportError(ex);
					consume();
					consumeUntil(_tokenSet_10);
				} else {
				  throw ex;
				}
			}
			returnAST = methode_AST;
		}
		
	public final void trigger() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST trigger_AST = null;
		
		try {      // for error handling
			AST tmp51_AST = null;
			tmp51_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp51_AST);
			match(TRIGGER);
			AST tmp52_AST = null;
			tmp52_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp52_AST);
			match(IDENTIFIER);
			AST tmp53_AST = null;
			tmp53_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp53_AST);
			match(OPEN_PAR);
			{
			switch ( LA(1)) {
			case IDENTIFIER:
			{
				parameters();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case CLOSE_PAR:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			AST tmp54_AST = null;
			tmp54_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp54_AST);
			match(CLOSE_PAR);
			{
			switch ( LA(1)) {
			case RETURN:
			{
				AST tmp55_AST = null;
				tmp55_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp55_AST);
				match(RETURN);
				AST tmp56_AST = null;
				tmp56_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp56_AST);
				match(IDENTIFIER);
				break;
			}
			case IS:
			case SEMI_COLON:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case IS:
			{
				AST tmp57_AST = null;
				tmp57_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp57_AST);
				match(IS);
				{
				switch ( LA(1)) {
				case IDENTIFIER:
				{
					variable();
					astFactory.addASTChild(currentAST, returnAST);
					break;
				}
				case CONST:
				{
					constant();
					astFactory.addASTChild(currentAST, returnAST);
					break;
				}
				case BEGIN:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				body();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case SEMI_COLON:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(SEMI_COLON);
			trigger_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_10);
			} else {
			  throw ex;
			}
		}
		returnAST = trigger_AST;
	}
	
	public final void declaration() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST declaration_AST = null;
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case TYPE:
			{
				type();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case IDENTIFIER:
			{
				variable();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case CONST:
			{
				constant();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case TRIGGER:
			{
				trigger();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case ASYNCHRONOUS:
			case FUNCTION:
			case PROCEDURE:
			case SYNCHRONOUS:
			{
				methode();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			declaration_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_0);
			} else {
			  throw ex;
			}
		}
		returnAST = declaration_AST;
	}
	
	public final void statement() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST statement_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case IF:
			{
				if_then_else();
				astFactory.addASTChild(currentAST, returnAST);
				match(SEMI_COLON);
				statement_AST = (AST)currentAST.root;
				break;
			}
			case BREAK:
			{
				break_statement();
				astFactory.addASTChild(currentAST, returnAST);
				match(SEMI_COLON);
				statement_AST = (AST)currentAST.root;
				break;
			}
			case GOTO:
			{
				goto_statement();
				astFactory.addASTChild(currentAST, returnAST);
				match(SEMI_COLON);
				statement_AST = (AST)currentAST.root;
				break;
			}
			case NULL_STATEMENT:
			{
				AST tmp62_AST = null;
				tmp62_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp62_AST);
				match(NULL_STATEMENT);
				match(SEMI_COLON);
				statement_AST = (AST)currentAST.root;
				break;
			}
			case RETURN:
			{
				return_statement();
				astFactory.addASTChild(currentAST, returnAST);
				match(SEMI_COLON);
				statement_AST = (AST)currentAST.root;
				break;
			}
			case ACCEPT:
			{
				accept_statement();
				astFactory.addASTChild(currentAST, returnAST);
				match(SEMI_COLON);
				statement_AST = (AST)currentAST.root;
				break;
			}
			default:
				boolean synPredMatched94 = false;
				if (((LA(1)==FOR||LA(1)==COLON) && (LA(2)==IDENTIFIER) && (LA(3)==FOR||LA(3)==IN))) {
					int _m94 = mark();
					synPredMatched94 = true;
					inputState.guessing++;
					try {
						{
						{
						switch ( LA(1)) {
						case COLON:
						{
							match(COLON);
							match(IDENTIFIER);
							break;
						}
						case FOR:
						{
							break;
						}
						default:
						{
							throw new NoViableAltException(LT(1), getFilename());
						}
						}
						}
						match(FOR);
						}
					}
					catch (RecognitionException pe) {
						synPredMatched94 = false;
					}
					rewind(_m94);
					inputState.guessing--;
				}
				if ( synPredMatched94 ) {
					for_loop();
					astFactory.addASTChild(currentAST, returnAST);
					match(SEMI_COLON);
					statement_AST = (AST)currentAST.root;
				}
				else {
					boolean synPredMatched97 = false;
					if (((LA(1)==WHILE||LA(1)==COLON) && (_tokenSet_11.member(LA(2))) && (_tokenSet_12.member(LA(3))))) {
						int _m97 = mark();
						synPredMatched97 = true;
						inputState.guessing++;
						try {
							{
							{
							switch ( LA(1)) {
							case COLON:
							{
								match(COLON);
								match(IDENTIFIER);
								break;
							}
							case WHILE:
							{
								break;
							}
							default:
							{
								throw new NoViableAltException(LT(1), getFilename());
							}
							}
							}
							match(WHILE);
							}
						}
						catch (RecognitionException pe) {
							synPredMatched97 = false;
						}
						rewind(_m97);
						inputState.guessing--;
					}
					if ( synPredMatched97 ) {
						while_loop();
						astFactory.addASTChild(currentAST, returnAST);
						match(SEMI_COLON);
						statement_AST = (AST)currentAST.root;
					}
					else {
						boolean synPredMatched99 = false;
						if (((LA(1)==IDENTIFIER) && (LA(2)==AFFECT||LA(2)==OPEN_PAR||LA(2)==DOT) && (_tokenSet_13.member(LA(3))))) {
							int _m99 = mark();
							synPredMatched99 = true;
							inputState.guessing++;
							try {
								{
								variable_occurence();
								match(AFFECT);
								}
							}
							catch (RecognitionException pe) {
								synPredMatched99 = false;
							}
							rewind(_m99);
							inputState.guessing--;
						}
						if ( synPredMatched99 ) {
							affectation();
							astFactory.addASTChild(currentAST, returnAST);
							match(SEMI_COLON);
							statement_AST = (AST)currentAST.root;
						}
						else {
							boolean synPredMatched102 = false;
							if (((LA(1)==DECLARE||LA(1)==COLON) && (LA(2)==BEGIN||LA(2)==CONST||LA(2)==IDENTIFIER) && (_tokenSet_14.member(LA(3))))) {
								int _m102 = mark();
								synPredMatched102 = true;
								inputState.guessing++;
								try {
									{
									{
									switch ( LA(1)) {
									case COLON:
									{
										match(COLON);
										match(IDENTIFIER);
										break;
									}
									case DECLARE:
									{
										break;
									}
									default:
									{
										throw new NoViableAltException(LT(1), getFilename());
									}
									}
									}
									match(DECLARE);
									}
								}
								catch (RecognitionException pe) {
									synPredMatched102 = false;
								}
								rewind(_m102);
								inputState.guessing--;
							}
							if ( synPredMatched102 ) {
								declare_bloc();
								astFactory.addASTChild(currentAST, returnAST);
								match(SEMI_COLON);
								statement_AST = (AST)currentAST.root;
							}
							else if ((LA(1)==COLON) && (LA(2)==IDENTIFIER) && (LA(3)==COLON)) {
								set_label();
								astFactory.addASTChild(currentAST, returnAST);
								statement_AST = (AST)currentAST.root;
							}
							else {
								boolean synPredMatched104 = false;
								if (((LA(1)==IDENTIFIER) && (LA(2)==OPEN_PAR||LA(2)==EXT_CALL||LA(2)==DOT) && (_tokenSet_13.member(LA(3))))) {
									int _m104 = mark();
									synPredMatched104 = true;
									inputState.guessing++;
									try {
										{
										variable_occurence();
										match(EXT_CALL);
										}
									}
									catch (RecognitionException pe) {
										synPredMatched104 = false;
									}
									rewind(_m104);
									inputState.guessing--;
								}
								if ( synPredMatched104 ) {
									external_call();
									astFactory.addASTChild(currentAST, returnAST);
									match(SEMI_COLON);
									statement_AST = (AST)currentAST.root;
								}
								else {
									boolean synPredMatched109 = false;
									if (((LA(1)==OPEN_PAR||LA(1)==OPEN_BRACKET) && (_tokenSet_11.member(LA(2))) && (_tokenSet_15.member(LA(3))))) {
										int _m109 = mark();
										synPredMatched109 = true;
										inputState.guessing++;
										try {
											{
											{
											switch ( LA(1)) {
											case OPEN_BRACKET:
											{
												discriminant();
												break;
											}
											case OPEN_PAR:
											{
												break;
											}
											default:
											{
												throw new NoViableAltException(LT(1), getFilename());
											}
											}
											}
											match(OPEN_PAR);
											expression();
											{
											_loop108:
											do {
												if ((LA(1)==COMA)) {
													match(COMA);
													expression();
												}
												else {
													break _loop108;
												}
												
											} while (true);
											}
											match(CLOSE_PAR);
											match(RIGHT_ARROW);
											}
										}
										catch (RecognitionException pe) {
											synPredMatched109 = false;
										}
										rewind(_m109);
										inputState.guessing--;
									}
									if ( synPredMatched109 ) {
										write_message();
										astFactory.addASTChild(currentAST, returnAST);
										match(SEMI_COLON);
										statement_AST = (AST)currentAST.root;
									}
									else {
										boolean synPredMatched112 = false;
										if (((LA(1)==OPEN_PAR||LA(1)==OPEN_BRACKET) && (_tokenSet_11.member(LA(2))) && (_tokenSet_15.member(LA(3))))) {
											int _m112 = mark();
											synPredMatched112 = true;
											inputState.guessing++;
											try {
												{
												{
												switch ( LA(1)) {
												case OPEN_BRACKET:
												{
													discriminant();
													break;
												}
												case OPEN_PAR:
												{
													break;
												}
												default:
												{
													throw new NoViableAltException(LT(1), getFilename());
												}
												}
												}
												match(OPEN_PAR);
												}
											}
											catch (RecognitionException pe) {
												synPredMatched112 = false;
											}
											rewind(_m112);
											inputState.guessing--;
										}
										if ( synPredMatched112 ) {
											read_message();
											astFactory.addASTChild(currentAST, returnAST);
											match(SEMI_COLON);
											statement_AST = (AST)currentAST.root;
										}
										else {
											boolean synPredMatched115 = false;
											if (((LA(1)==IDENTIFIER||LA(1)==OPEN_BRACKET) && (_tokenSet_16.member(LA(2))) && (_tokenSet_15.member(LA(3))))) {
												int _m115 = mark();
												synPredMatched115 = true;
												inputState.guessing++;
												try {
													{
													{
													switch ( LA(1)) {
													case OPEN_BRACKET:
													{
														discriminant();
														break;
													}
													case IDENTIFIER:
													{
														break;
													}
													default:
													{
														throw new NoViableAltException(LT(1), getFilename());
													}
													}
													}
													match(IDENTIFIER);
													}
												}
												catch (RecognitionException pe) {
													synPredMatched115 = false;
												}
												rewind(_m115);
												inputState.guessing--;
											}
											if ( synPredMatched115 ) {
												procedure_call();
												astFactory.addASTChild(currentAST, returnAST);
												match(SEMI_COLON);
												statement_AST = (AST)currentAST.root;
											}
											else if ((LA(1)==IDENTIFIER) && (LA(2)==LEFT_ARROW)) {
												attente_activation();
												astFactory.addASTChild(currentAST, returnAST);
												match(SEMI_COLON);
												statement_AST = (AST)currentAST.root;
											}
										else {
											throw new NoViableAltException(LT(1), getFilename());
										}
										}}}}}}}}
									}
									catch (RecognitionException ex) {
										if (inputState.guessing==0) {
											reportError(ex);
											consume();
											consumeUntil(_tokenSet_17);
										} else {
										  throw ex;
										}
									}
									returnAST = statement_AST;
								}
								
	public final void type_declaration() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST type_declaration_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case ARRAY:
			{
				AST tmp75_AST = null;
				tmp75_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp75_AST);
				match(ARRAY);
				AST tmp76_AST = null;
				tmp76_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp76_AST);
				match(OPEN_PAR);
				range();
				astFactory.addASTChild(currentAST, returnAST);
				{
				_loop39:
				do {
					if ((LA(1)==COMA)) {
						AST tmp77_AST = null;
						tmp77_AST = astFactory.create(LT(1));
						astFactory.addASTChild(currentAST, tmp77_AST);
						match(COMA);
						range();
						astFactory.addASTChild(currentAST, returnAST);
					}
					else {
						break _loop39;
					}
					
				} while (true);
				}
				AST tmp78_AST = null;
				tmp78_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp78_AST);
				match(CLOSE_PAR);
				AST tmp79_AST = null;
				tmp79_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp79_AST);
				match(OF);
				AST tmp80_AST = null;
				tmp80_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp80_AST);
				match(IDENTIFIER);
				type_declaration_AST = (AST)currentAST.root;
				break;
			}
			case CIRCULAR:
			case RANGE:
			{
				{
				switch ( LA(1)) {
				case CIRCULAR:
				{
					AST tmp81_AST = null;
					tmp81_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp81_AST);
					match(CIRCULAR);
					break;
				}
				case RANGE:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				AST tmp82_AST = null;
				tmp82_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp82_AST);
				match(RANGE);
				range();
				astFactory.addASTChild(currentAST, returnAST);
				match(OF);
				AST tmp84_AST = null;
				tmp84_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp84_AST);
				match(IDENTIFIER);
				type_declaration_AST = (AST)currentAST.root;
				break;
			}
			case BAG:
			case SET:
			{
				{
				switch ( LA(1)) {
				case SET:
				{
					AST tmp85_AST = null;
					tmp85_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp85_AST);
					match(SET);
					break;
				}
				case BAG:
				{
					AST tmp86_AST = null;
					tmp86_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp86_AST);
					match(BAG);
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				match(OF);
				AST tmp88_AST = null;
				tmp88_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp88_AST);
				match(IDENTIFIER);
				type_declaration_AST = (AST)currentAST.root;
				break;
			}
			case ENUM:
			{
				AST tmp89_AST = null;
				tmp89_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp89_AST);
				match(ENUM);
				match(OPEN_PAR);
				AST tmp91_AST = null;
				tmp91_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp91_AST);
				match(IDENTIFIER);
				{
				_loop43:
				do {
					if ((LA(1)==COMA)) {
						match(COMA);
						AST tmp93_AST = null;
						tmp93_AST = astFactory.create(LT(1));
						astFactory.addASTChild(currentAST, tmp93_AST);
						match(IDENTIFIER);
					}
					else {
						break _loop43;
					}
					
				} while (true);
				}
				match(CLOSE_PAR);
				type_declaration_AST = (AST)currentAST.root;
				break;
			}
			case PORT:
			{
				AST tmp95_AST = null;
				tmp95_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp95_AST);
				match(PORT);
				match(OPEN_PAR);
				AST tmp97_AST = null;
				tmp97_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp97_AST);
				match(IDENTIFIER);
				{
				_loop45:
				do {
					if ((LA(1)==COMA)) {
						match(COMA);
						AST tmp99_AST = null;
						tmp99_AST = astFactory.create(LT(1));
						astFactory.addASTChild(currentAST, tmp99_AST);
						match(IDENTIFIER);
					}
					else {
						break _loop45;
					}
					
				} while (true);
				}
				match(CLOSE_PAR);
				type_declaration_AST = (AST)currentAST.root;
				break;
			}
			case OPAQUE:
			{
				AST tmp101_AST = null;
				tmp101_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp101_AST);
				match(OPAQUE);
				{
				switch ( LA(1)) {
				case FUNCTION:
				case PROCEDURE:
				{
					{
					int _cnt48=0;
					_loop48:
					do {
						if ((LA(1)==FUNCTION||LA(1)==PROCEDURE)) {
							external_method();
							astFactory.addASTChild(currentAST, returnAST);
						}
						else {
							if ( _cnt48>=1 ) { break _loop48; } else {throw new NoViableAltException(LT(1), getFilename());}
						}
						
						_cnt48++;
					} while (true);
					}
					match(END);
					break;
				}
				case SEMI_COLON:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				type_declaration_AST = (AST)currentAST.root;
				break;
			}
			case RECORD:
			{
				AST tmp103_AST = null;
				tmp103_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp103_AST);
				match(RECORD);
				{
				int _cnt50=0;
				_loop50:
				do {
					if ((LA(1)==IDENTIFIER)) {
						field();
						astFactory.addASTChild(currentAST, returnAST);
					}
					else {
						if ( _cnt50>=1 ) { break _loop50; } else {throw new NoViableAltException(LT(1), getFilename());}
					}
					
					_cnt50++;
				} while (true);
				}
				match(END);
				type_declaration_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_7);
			} else {
			  throw ex;
			}
		}
		returnAST = type_declaration_AST;
	}
	
	public final void range() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST range_AST = null;
		
		try {      // for error handling
			expression();
			astFactory.addASTChild(currentAST, returnAST);
			AST tmp105_AST = null;
			tmp105_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp105_AST);
			match(RANGE_OP);
			expression();
			astFactory.addASTChild(currentAST, returnAST);
			range_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_18);
			} else {
			  throw ex;
			}
		}
		returnAST = range_AST;
	}
	
	public final void external_method() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST external_method_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case PROCEDURE:
			{
				AST tmp106_AST = null;
				tmp106_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp106_AST);
				match(PROCEDURE);
				AST tmp107_AST = null;
				tmp107_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp107_AST);
				match(IDENTIFIER);
				match(OPEN_PAR);
				{
				switch ( LA(1)) {
				case IDENTIFIER:
				{
					parameters();
					astFactory.addASTChild(currentAST, returnAST);
					break;
				}
				case CLOSE_PAR:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				match(CLOSE_PAR);
				AST tmp110_AST = null;
				tmp110_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp110_AST);
				match(SEMI_COLON);
				external_method_AST = (AST)currentAST.root;
				break;
			}
			case FUNCTION:
			{
				AST tmp111_AST = null;
				tmp111_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp111_AST);
				match(FUNCTION);
				AST tmp112_AST = null;
				tmp112_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp112_AST);
				match(IDENTIFIER);
				match(OPEN_PAR);
				{
				switch ( LA(1)) {
				case IDENTIFIER:
				{
					parameters();
					astFactory.addASTChild(currentAST, returnAST);
					break;
				}
				case CLOSE_PAR:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				match(CLOSE_PAR);
				AST tmp115_AST = null;
				tmp115_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp115_AST);
				match(RETURN);
				AST tmp116_AST = null;
				tmp116_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp116_AST);
				match(IDENTIFIER);
				AST tmp117_AST = null;
				tmp117_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp117_AST);
				match(SEMI_COLON);
				external_method_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_19);
			} else {
			  throw ex;
			}
		}
		returnAST = external_method_AST;
	}
	
	public final void field() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST field_AST = null;
		
		try {      // for error handling
			AST tmp118_AST = null;
			tmp118_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp118_AST);
			match(IDENTIFIER);
			{
			_loop56:
			do {
				if ((LA(1)==COMA)) {
					match(COMA);
					AST tmp120_AST = null;
					tmp120_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp120_AST);
					match(IDENTIFIER);
				}
				else {
					break _loop56;
				}
				
			} while (true);
			}
			AST tmp121_AST = null;
			tmp121_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp121_AST);
			match(COLON);
			AST tmp122_AST = null;
			tmp122_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp122_AST);
			match(IDENTIFIER);
			match(SEMI_COLON);
			if ( inputState.guessing==0 ) {
				field_AST = (AST)currentAST.root;
				field_AST = (AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(FIELD,"FIELD")).add(field_AST));
				currentAST.root = field_AST;
				currentAST.child = field_AST!=null &&field_AST.getFirstChild()!=null ?
					field_AST.getFirstChild() : field_AST;
				currentAST.advanceChildToEnd();
			}
			field_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_20);
			} else {
			  throw ex;
			}
		}
		returnAST = field_AST;
	}
	
	public final void parameters() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST parameters_AST = null;
		
		try {      // for error handling
			parameter();
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop88:
			do {
				if ((LA(1)==SEMI_COLON)) {
					match(SEMI_COLON);
					parameter();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop88;
				}
				
			} while (true);
			}
			parameters_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_21);
			} else {
			  throw ex;
			}
		}
		returnAST = parameters_AST;
	}
	
	public final void expression() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST expression_AST = null;
		
		try {      // for error handling
			if ((_tokenSet_11.member(LA(1))) && (_tokenSet_22.member(LA(2)))) {
				simpleExpression();
				astFactory.addASTChild(currentAST, returnAST);
				{
				_loop195:
				do {
					if (((LA(1) >= EQUAL && LA(1) <= GREATER_EQ))) {
						{
						switch ( LA(1)) {
						case EQUAL:
						{
							AST tmp125_AST = null;
							tmp125_AST = astFactory.create(LT(1));
							astFactory.makeASTRoot(currentAST, tmp125_AST);
							match(EQUAL);
							break;
						}
						case DIFF:
						{
							AST tmp126_AST = null;
							tmp126_AST = astFactory.create(LT(1));
							astFactory.makeASTRoot(currentAST, tmp126_AST);
							match(DIFF);
							break;
						}
						case LESS:
						{
							AST tmp127_AST = null;
							tmp127_AST = astFactory.create(LT(1));
							astFactory.makeASTRoot(currentAST, tmp127_AST);
							match(LESS);
							break;
						}
						case LESS_EQ:
						{
							AST tmp128_AST = null;
							tmp128_AST = astFactory.create(LT(1));
							astFactory.makeASTRoot(currentAST, tmp128_AST);
							match(LESS_EQ);
							break;
						}
						case GREATER:
						{
							AST tmp129_AST = null;
							tmp129_AST = astFactory.create(LT(1));
							astFactory.makeASTRoot(currentAST, tmp129_AST);
							match(GREATER);
							break;
						}
						case GREATER_EQ:
						{
							AST tmp130_AST = null;
							tmp130_AST = astFactory.create(LT(1));
							astFactory.makeASTRoot(currentAST, tmp130_AST);
							match(GREATER_EQ);
							break;
						}
						default:
						{
							throw new NoViableAltException(LT(1), getFilename());
						}
						}
						}
						simpleExpression();
						astFactory.addASTChild(currentAST, returnAST);
					}
					else {
						break _loop195;
					}
					
				} while (true);
				}
				expression_AST = (AST)currentAST.root;
			}
			else if ((LA(1)==IDENTIFIER) && (LA(2)==QUOTE)) {
				AST tmp131_AST = null;
				tmp131_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp131_AST);
				match(IDENTIFIER);
				AST tmp132_AST = null;
				tmp132_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp132_AST);
				match(QUOTE);
				expression();
				astFactory.addASTChild(currentAST, returnAST);
				expression_AST = (AST)currentAST.root;
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_23);
			} else {
			  throw ex;
			}
		}
		returnAST = expression_AST;
	}
	
	public final void function() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST function_AST = null;
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case SYNCHRONOUS:
			{
				AST tmp133_AST = null;
				tmp133_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp133_AST);
				match(SYNCHRONOUS);
				break;
			}
			case FUNCTION:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			AST tmp134_AST = null;
			tmp134_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp134_AST);
			match(FUNCTION);
			AST tmp135_AST = null;
			tmp135_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp135_AST);
			match(IDENTIFIER);
			match(OPEN_PAR);
			{
			switch ( LA(1)) {
			case IDENTIFIER:
			{
				parameters();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case CLOSE_PAR:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(CLOSE_PAR);
			AST tmp138_AST = null;
			tmp138_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp138_AST);
			match(RETURN);
			AST tmp139_AST = null;
			tmp139_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp139_AST);
			match(IDENTIFIER);
			{
			switch ( LA(1)) {
			case RIGHT_ARROW:
			{
				AST tmp140_AST = null;
				tmp140_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp140_AST);
				match(RIGHT_ARROW);
				expression();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case IS:
			case SEMI_COLON:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case IS:
			{
				AST tmp141_AST = null;
				tmp141_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp141_AST);
				match(IS);
				{
				_loop85:
				do {
					switch ( LA(1)) {
					case IDENTIFIER:
					{
						variable();
						astFactory.addASTChild(currentAST, returnAST);
						break;
					}
					case CONST:
					{
						constant();
						astFactory.addASTChild(currentAST, returnAST);
						break;
					}
					default:
					{
						break _loop85;
					}
					}
				} while (true);
				}
				body();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case SEMI_COLON:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(SEMI_COLON);
			function_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_10);
			} else {
			  throw ex;
			}
		}
		returnAST = function_AST;
	}
	
	public final void procedure() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST procedure_AST = null;
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case ASYNCHRONOUS:
			{
				AST tmp143_AST = null;
				tmp143_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp143_AST);
				match(ASYNCHRONOUS);
				break;
			}
			case SYNCHRONOUS:
			{
				AST tmp144_AST = null;
				tmp144_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp144_AST);
				match(SYNCHRONOUS);
				break;
			}
			case PROCEDURE:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			AST tmp145_AST = null;
			tmp145_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp145_AST);
			match(PROCEDURE);
			AST tmp146_AST = null;
			tmp146_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp146_AST);
			match(IDENTIFIER);
			AST tmp147_AST = null;
			tmp147_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp147_AST);
			match(OPEN_PAR);
			{
			switch ( LA(1)) {
			case IDENTIFIER:
			{
				parameters();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case CLOSE_PAR:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			AST tmp148_AST = null;
			tmp148_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp148_AST);
			match(CLOSE_PAR);
			{
			switch ( LA(1)) {
			case RIGHT_ARROW:
			{
				AST tmp149_AST = null;
				tmp149_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp149_AST);
				match(RIGHT_ARROW);
				expression();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case IS:
			case SEMI_COLON:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			switch ( LA(1)) {
			case IS:
			{
				AST tmp150_AST = null;
				tmp150_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp150_AST);
				match(IS);
				{
				_loop78:
				do {
					switch ( LA(1)) {
					case IDENTIFIER:
					{
						variable();
						astFactory.addASTChild(currentAST, returnAST);
						break;
					}
					case CONST:
					{
						constant();
						astFactory.addASTChild(currentAST, returnAST);
						break;
					}
					default:
					{
						break _loop78;
					}
					}
				} while (true);
				}
				body();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case SEMI_COLON:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(SEMI_COLON);
			procedure_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_10);
			} else {
			  throw ex;
			}
		}
		returnAST = procedure_AST;
	}
	
	public final void parameter() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST parameter_AST = null;
		
		try {      // for error handling
			AST tmp152_AST = null;
			tmp152_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp152_AST);
			match(IDENTIFIER);
			AST tmp153_AST = null;
			tmp153_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp153_AST);
			match(COLON);
			{
			switch ( LA(1)) {
			case IN:
			{
				AST tmp154_AST = null;
				tmp154_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp154_AST);
				match(IN);
				break;
			}
			case INOUT:
			{
				AST tmp155_AST = null;
				tmp155_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp155_AST);
				match(INOUT);
				break;
			}
			case OUT:
			{
				AST tmp156_AST = null;
				tmp156_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp156_AST);
				match(OUT);
				break;
			}
			case IDENTIFIER:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			AST tmp157_AST = null;
			tmp157_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp157_AST);
			match(IDENTIFIER);
			parameter_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_24);
			} else {
			  throw ex;
			}
		}
		returnAST = parameter_AST;
	}
	
	public final void if_then_else() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST if_then_else_AST = null;
		
		try {      // for error handling
			AST tmp158_AST = null;
			tmp158_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp158_AST);
			match(IF);
			expression();
			astFactory.addASTChild(currentAST, returnAST);
			match(THEN);
			statements();
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop123:
			do {
				if ((LA(1)==ELSIF)) {
					AST tmp160_AST = null;
					tmp160_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp160_AST);
					match(ELSIF);
					expression();
					astFactory.addASTChild(currentAST, returnAST);
					match(THEN);
					statements();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop123;
				}
				
			} while (true);
			}
			{
			switch ( LA(1)) {
			case ELSE:
			{
				AST tmp162_AST = null;
				tmp162_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp162_AST);
				match(ELSE);
				statements();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case END:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(END);
			if_then_else_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_7);
			} else {
			  throw ex;
			}
		}
		returnAST = if_then_else_AST;
	}
	
	public final void for_loop() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST for_loop_AST = null;
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case COLON:
			{
				match(COLON);
				AST tmp165_AST = null;
				tmp165_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp165_AST);
				match(IDENTIFIER);
				break;
			}
			case FOR:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			AST tmp166_AST = null;
			tmp166_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp166_AST);
			match(FOR);
			AST tmp167_AST = null;
			tmp167_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp167_AST);
			match(IDENTIFIER);
			match(IN);
			range();
			astFactory.addASTChild(currentAST, returnAST);
			body();
			astFactory.addASTChild(currentAST, returnAST);
			for_loop_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_7);
			} else {
			  throw ex;
			}
		}
		returnAST = for_loop_AST;
	}
	
	public final void while_loop() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST while_loop_AST = null;
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case COLON:
			{
				match(COLON);
				AST tmp170_AST = null;
				tmp170_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp170_AST);
				match(IDENTIFIER);
				break;
			}
			case WHILE:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			AST tmp171_AST = null;
			tmp171_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp171_AST);
			match(WHILE);
			expression();
			astFactory.addASTChild(currentAST, returnAST);
			body();
			astFactory.addASTChild(currentAST, returnAST);
			while_loop_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_7);
			} else {
			  throw ex;
			}
		}
		returnAST = while_loop_AST;
	}
	
	public final void break_statement() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST break_statement_AST = null;
		
		try {      // for error handling
			AST tmp172_AST = null;
			tmp172_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp172_AST);
			match(BREAK);
			{
			switch ( LA(1)) {
			case IDENTIFIER:
			{
				AST tmp173_AST = null;
				tmp173_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp173_AST);
				match(IDENTIFIER);
				break;
			}
			case SEMI_COLON:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			break_statement_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_7);
			} else {
			  throw ex;
			}
		}
		returnAST = break_statement_AST;
	}
	
	public final void variable_occurence() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST variable_occurence_AST = null;
		
		try {      // for error handling
			atomic_variable();
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop220:
			do {
				if ((LA(1)==DOT)) {
					AST tmp174_AST = null;
					tmp174_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp174_AST);
					match(DOT);
					atomic_variable();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop220;
				}
				
			} while (true);
			}
			variable_occurence_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_25);
			} else {
			  throw ex;
			}
		}
		returnAST = variable_occurence_AST;
	}
	
	public final void affectation() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST affectation_AST = null;
		
		try {      // for error handling
			variable_occurence();
			astFactory.addASTChild(currentAST, returnAST);
			AST tmp175_AST = null;
			tmp175_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp175_AST);
			match(AFFECT);
			expression();
			astFactory.addASTChild(currentAST, returnAST);
			affectation_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_7);
			} else {
			  throw ex;
			}
		}
		returnAST = affectation_AST;
	}
	
	public final void goto_statement() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST goto_statement_AST = null;
		
		try {      // for error handling
			AST tmp176_AST = null;
			tmp176_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp176_AST);
			match(GOTO);
			AST tmp177_AST = null;
			tmp177_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp177_AST);
			match(IDENTIFIER);
			goto_statement_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_7);
			} else {
			  throw ex;
			}
		}
		returnAST = goto_statement_AST;
	}
	
	public final void declare_bloc() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST declare_bloc_AST = null;
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case COLON:
			{
				match(COLON);
				AST tmp179_AST = null;
				tmp179_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp179_AST);
				match(IDENTIFIER);
				break;
			}
			case DECLARE:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			AST tmp180_AST = null;
			tmp180_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp180_AST);
			match(DECLARE);
			{
			_loop135:
			do {
				switch ( LA(1)) {
				case IDENTIFIER:
				{
					variable();
					astFactory.addASTChild(currentAST, returnAST);
					break;
				}
				case CONST:
				{
					constant();
					astFactory.addASTChild(currentAST, returnAST);
					break;
				}
				default:
				{
					break _loop135;
				}
				}
			} while (true);
			}
			body();
			astFactory.addASTChild(currentAST, returnAST);
			declare_bloc_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_7);
			} else {
			  throw ex;
			}
		}
		returnAST = declare_bloc_AST;
	}
	
	public final void set_label() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST set_label_AST = null;
		
		try {      // for error handling
			match(COLON);
			AST tmp182_AST = null;
			tmp182_AST = astFactory.create(LT(1));
			match(IDENTIFIER);
			match(COLON);
			if ( inputState.guessing==0 ) {
				set_label_AST = (AST)currentAST.root;
				set_label_AST=(AST)astFactory.make( (new ASTArray(2)).add(astFactory.create(LABEL,"LABEL")).add(tmp182_AST));
				currentAST.root = set_label_AST;
				currentAST.child = set_label_AST!=null &&set_label_AST.getFirstChild()!=null ?
					set_label_AST.getFirstChild() : set_label_AST;
				currentAST.advanceChildToEnd();
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_17);
			} else {
			  throw ex;
			}
		}
		returnAST = set_label_AST;
	}
	
	public final void external_call() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST external_call_AST = null;
		
		try {      // for error handling
			variable_occurence();
			astFactory.addASTChild(currentAST, returnAST);
			AST tmp184_AST = null;
			tmp184_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp184_AST);
			match(EXT_CALL);
			AST tmp185_AST = null;
			tmp185_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp185_AST);
			match(IDENTIFIER);
			match(OPEN_PAR);
			{
			switch ( LA(1)) {
			case FALSE:
			case NOT:
			case NEW:
			case NULL_STATEMENT:
			case TRUE:
			case IDENTIFIER:
			case OPEN_PAR:
			case OPEN_BRACKET:
			case PLUS:
			case MINUS:
			case INTEGER:
			{
				expression();
				astFactory.addASTChild(currentAST, returnAST);
				{
				_loop186:
				do {
					if ((LA(1)==COMA)) {
						AST tmp187_AST = null;
						tmp187_AST = astFactory.create(LT(1));
						astFactory.addASTChild(currentAST, tmp187_AST);
						match(COMA);
						expression();
						astFactory.addASTChild(currentAST, returnAST);
					}
					else {
						break _loop186;
					}
					
				} while (true);
				}
				break;
			}
			case CLOSE_PAR:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(CLOSE_PAR);
			external_call_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_26);
			} else {
			  throw ex;
			}
		}
		returnAST = external_call_AST;
	}
	
	public final void discriminant() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST discriminant_AST = null;
		
		try {      // for error handling
			AST tmp189_AST = null;
			tmp189_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp189_AST);
			match(OPEN_BRACKET);
			expression();
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop189:
			do {
				if ((LA(1)==COMA)) {
					AST tmp190_AST = null;
					tmp190_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp190_AST);
					match(COMA);
					expression();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop189;
				}
				
			} while (true);
			}
			match(CLOSE_BRACKET);
			discriminant_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_27);
			} else {
			  throw ex;
			}
		}
		returnAST = discriminant_AST;
	}
	
	public final void write_message() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST write_message_AST = null;
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case OPEN_BRACKET:
			{
				discriminant();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case OPEN_PAR:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(OPEN_PAR);
			expression();
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop169:
			do {
				if ((LA(1)==COMA)) {
					AST tmp193_AST = null;
					tmp193_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp193_AST);
					match(COMA);
					expression();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop169;
				}
				
			} while (true);
			}
			match(CLOSE_PAR);
			AST tmp195_AST = null;
			tmp195_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp195_AST);
			match(RIGHT_ARROW);
			variable_occurence();
			astFactory.addASTChild(currentAST, returnAST);
			write_message_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_7);
			} else {
			  throw ex;
			}
		}
		returnAST = write_message_AST;
	}
	
	public final void read_message() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST read_message_AST = null;
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case OPEN_BRACKET:
			{
				discriminant();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case OPEN_PAR:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			match(OPEN_PAR);
			expression();
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop164:
			do {
				if ((LA(1)==COMA)) {
					AST tmp197_AST = null;
					tmp197_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp197_AST);
					match(COMA);
					expression();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop164;
				}
				
			} while (true);
			}
			match(CLOSE_PAR);
			AST tmp199_AST = null;
			tmp199_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp199_AST);
			match(LEFT_ARROW);
			variable_occurence();
			astFactory.addASTChild(currentAST, returnAST);
			{
			switch ( LA(1)) {
			case WITH:
			{
				AST tmp200_AST = null;
				tmp200_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp200_AST);
				match(WITH);
				expression();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case SEMI_COLON:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			read_message_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_7);
			} else {
			  throw ex;
			}
		}
		returnAST = read_message_AST;
	}
	
	public final void procedure_call() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST procedure_call_AST = null;
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case OPEN_BRACKET:
			{
				discriminant();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case IDENTIFIER:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			if ((LA(1)==IDENTIFIER) && (LA(2)==COLON)) {
				AST tmp201_AST = null;
				tmp201_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp201_AST);
				match(IDENTIFIER);
				AST tmp202_AST = null;
				tmp202_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp202_AST);
				match(COLON);
			}
			else if ((LA(1)==IDENTIFIER) && (LA(2)==OPEN_PAR)) {
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
			}
			AST tmp203_AST = null;
			tmp203_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp203_AST);
			match(IDENTIFIER);
			AST tmp204_AST = null;
			tmp204_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp204_AST);
			match(OPEN_PAR);
			{
			switch ( LA(1)) {
			case FALSE:
			case NOT:
			case NEW:
			case NULL_STATEMENT:
			case TRUE:
			case IDENTIFIER:
			case OPEN_PAR:
			case OPEN_BRACKET:
			case PLUS:
			case MINUS:
			case INTEGER:
			{
				expression();
				astFactory.addASTChild(currentAST, returnAST);
				{
				_loop175:
				do {
					if ((LA(1)==COMA)) {
						AST tmp205_AST = null;
						tmp205_AST = astFactory.create(LT(1));
						astFactory.addASTChild(currentAST, tmp205_AST);
						match(COMA);
						expression();
						astFactory.addASTChild(currentAST, returnAST);
					}
					else {
						break _loop175;
					}
					
				} while (true);
				}
				break;
			}
			case CLOSE_PAR:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			AST tmp206_AST = null;
			tmp206_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp206_AST);
			match(CLOSE_PAR);
			{
			switch ( LA(1)) {
			case RIGHT_ARROW:
			{
				AST tmp207_AST = null;
				tmp207_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp207_AST);
				match(RIGHT_ARROW);
				break;
			}
			case ARROW:
			{
				AST tmp208_AST = null;
				tmp208_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp208_AST);
				match(ARROW);
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			variable_occurence();
			astFactory.addASTChild(currentAST, returnAST);
			procedure_call_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_7);
			} else {
			  throw ex;
			}
		}
		returnAST = procedure_call_AST;
	}
	
	public final void return_statement() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST return_statement_AST = null;
		
		try {      // for error handling
			AST tmp209_AST = null;
			tmp209_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp209_AST);
			match(RETURN);
			{
			switch ( LA(1)) {
			case FALSE:
			case NOT:
			case NEW:
			case NULL_STATEMENT:
			case TRUE:
			case IDENTIFIER:
			case OPEN_PAR:
			case OPEN_BRACKET:
			case PLUS:
			case MINUS:
			case INTEGER:
			{
				expression();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case SEMI_COLON:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			return_statement_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_7);
			} else {
			  throw ex;
			}
		}
		returnAST = return_statement_AST;
	}
	
	public final void attente_activation() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST attente_activation_AST = null;
		
		try {      // for error handling
			AST tmp210_AST = null;
			tmp210_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp210_AST);
			match(IDENTIFIER);
			AST tmp211_AST = null;
			tmp211_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp211_AST);
			match(LEFT_ARROW);
			source_activation();
			astFactory.addASTChild(currentAST, returnAST);
			attente_activation_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_28);
			} else {
			  throw ex;
			}
		}
		returnAST = attente_activation_AST;
	}
	
	public final void accept_statement() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST accept_statement_AST = null;
		
		try {      // for error handling
			AST tmp212_AST = null;
			tmp212_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp212_AST);
			match(ACCEPT);
			attente_activation();
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop140:
			do {
				if ((LA(1)==COMA)) {
					match(COMA);
					attente_activation();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop140;
				}
				
			} while (true);
			}
			match(END);
			accept_statement_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_7);
			} else {
			  throw ex;
			}
		}
		returnAST = accept_statement_AST;
	}
	
	public final void statements() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST statements_AST = null;
		
		try {      // for error handling
			{
			int _cnt120=0;
			_loop120:
			do {
				if ((_tokenSet_6.member(LA(1)))) {
					statement();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					if ( _cnt120>=1 ) { break _loop120; } else {throw new NoViableAltException(LT(1), getFilename());}
				}
				
				_cnt120++;
			} while (true);
			}
			statements_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_29);
			} else {
			  throw ex;
			}
		}
		returnAST = statements_AST;
	}
	
	public final void source_activation() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST source_activation_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case IDENTIFIER:
			{
				variable_occurence();
				astFactory.addASTChild(currentAST, returnAST);
				source_activation_AST = (AST)currentAST.root;
				break;
			}
			case OPEN_PAR:
			{
				AST tmp215_AST = null;
				tmp215_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp215_AST);
				match(OPEN_PAR);
				AST tmp216_AST = null;
				tmp216_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp216_AST);
				match(CLOSE_PAR);
				source_activation_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_28);
			} else {
			  throw ex;
			}
		}
		returnAST = source_activation_AST;
	}
	
	public final void readers() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST readers_AST = null;
		
		try {      // for error handling
			AST tmp217_AST = null;
			tmp217_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp217_AST);
			match(IDENTIFIER);
			AST tmp218_AST = null;
			tmp218_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp218_AST);
			match(CAN_READ);
			AST tmp219_AST = null;
			tmp219_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp219_AST);
			match(IDENTIFIER);
			{
			_loop146:
			do {
				if ((LA(1)==COMA)) {
					match(COMA);
					AST tmp221_AST = null;
					tmp221_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp221_AST);
					match(IDENTIFIER);
				}
				else {
					break _loop146;
				}
				
			} while (true);
			}
			match(SEMI_COLON);
			readers_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_30);
			} else {
			  throw ex;
			}
		}
		returnAST = readers_AST;
	}
	
	public final void writers() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST writers_AST = null;
		
		try {      // for error handling
			AST tmp223_AST = null;
			tmp223_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp223_AST);
			match(IDENTIFIER);
			AST tmp224_AST = null;
			tmp224_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp224_AST);
			match(CAN_WRITE);
			AST tmp225_AST = null;
			tmp225_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp225_AST);
			match(IDENTIFIER);
			{
			_loop149:
			do {
				if ((LA(1)==COMA)) {
					match(COMA);
					AST tmp227_AST = null;
					tmp227_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp227_AST);
					match(IDENTIFIER);
				}
				else {
					break _loop149;
				}
				
			} while (true);
			}
			match(SEMI_COLON);
			writers_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_31);
			} else {
			  throw ex;
			}
		}
		returnAST = writers_AST;
	}
	
	public final void linked_components() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST linked_components_AST = null;
		
		try {      // for error handling
			AST tmp229_AST = null;
			tmp229_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp229_AST);
			match(OPEN_PAR);
			AST tmp230_AST = null;
			tmp230_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp230_AST);
			match(IDENTIFIER);
			{
			_loop154:
			do {
				if ((LA(1)==COMA)) {
					AST tmp231_AST = null;
					tmp231_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp231_AST);
					match(COMA);
					AST tmp232_AST = null;
					tmp232_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp232_AST);
					match(IDENTIFIER);
				}
				else {
					break _loop154;
				}
				
			} while (true);
			}
			match(CLOSE_PAR);
			linked_components_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_32);
			} else {
			  throw ex;
			}
		}
		returnAST = linked_components_AST;
	}
	
	public final void list_of_list() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST list_of_list_AST = null;
		
		try {      // for error handling
			AST tmp234_AST = null;
			tmp234_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp234_AST);
			match(OPEN_PAR);
			linked_components();
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop157:
			do {
				if ((LA(1)==COMA)) {
					AST tmp235_AST = null;
					tmp235_AST = astFactory.create(LT(1));
					astFactory.addASTChild(currentAST, tmp235_AST);
					match(COMA);
					linked_components();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop157;
				}
				
			} while (true);
			}
			match(CLOSE_PAR);
			list_of_list_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_7);
			} else {
			  throw ex;
			}
		}
		returnAST = list_of_list_AST;
	}
	
	public final void function_call() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST function_call_AST = null;
		
		try {      // for error handling
			{
			switch ( LA(1)) {
			case OPEN_BRACKET:
			{
				discriminant();
				astFactory.addASTChild(currentAST, returnAST);
				break;
			}
			case IDENTIFIER:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			{
			if ((LA(1)==IDENTIFIER) && (LA(2)==COLON)) {
				AST tmp237_AST = null;
				tmp237_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp237_AST);
				match(IDENTIFIER);
				AST tmp238_AST = null;
				tmp238_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp238_AST);
				match(COLON);
			}
			else if ((LA(1)==IDENTIFIER) && (LA(2)==OPEN_PAR)) {
			}
			else {
				throw new NoViableAltException(LT(1), getFilename());
			}
			
			}
			AST tmp239_AST = null;
			tmp239_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp239_AST);
			match(IDENTIFIER);
			AST tmp240_AST = null;
			tmp240_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp240_AST);
			match(OPEN_PAR);
			{
			switch ( LA(1)) {
			case FALSE:
			case NOT:
			case NEW:
			case NULL_STATEMENT:
			case TRUE:
			case IDENTIFIER:
			case OPEN_PAR:
			case OPEN_BRACKET:
			case PLUS:
			case MINUS:
			case INTEGER:
			{
				expression();
				astFactory.addASTChild(currentAST, returnAST);
				{
				_loop182:
				do {
					if ((LA(1)==COMA)) {
						AST tmp241_AST = null;
						tmp241_AST = astFactory.create(LT(1));
						astFactory.addASTChild(currentAST, tmp241_AST);
						match(COMA);
						expression();
						astFactory.addASTChild(currentAST, returnAST);
					}
					else {
						break _loop182;
					}
					
				} while (true);
				}
				break;
			}
			case CLOSE_PAR:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			AST tmp242_AST = null;
			tmp242_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp242_AST);
			match(CLOSE_PAR);
			AST tmp243_AST = null;
			tmp243_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp243_AST);
			match(EQUIV);
			variable_occurence();
			astFactory.addASTChild(currentAST, returnAST);
			function_call_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_26);
			} else {
			  throw ex;
			}
		}
		returnAST = function_call_AST;
	}
	
	public final void simpleExpression() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST simpleExpression_AST = null;
		
		try {      // for error handling
			term();
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop199:
			do {
				if ((LA(1)==OR||LA(1)==PLUS||LA(1)==MINUS)) {
					{
					switch ( LA(1)) {
					case PLUS:
					{
						AST tmp244_AST = null;
						tmp244_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp244_AST);
						match(PLUS);
						break;
					}
					case MINUS:
					{
						AST tmp245_AST = null;
						tmp245_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp245_AST);
						match(MINUS);
						break;
					}
					case OR:
					{
						AST tmp246_AST = null;
						tmp246_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp246_AST);
						match(OR);
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					term();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop199;
				}
				
			} while (true);
			}
			simpleExpression_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_33);
			} else {
			  throw ex;
			}
		}
		returnAST = simpleExpression_AST;
	}
	
	public final void term() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST term_AST = null;
		
		try {      // for error handling
			signedFactor();
			astFactory.addASTChild(currentAST, returnAST);
			{
			_loop203:
			do {
				if ((LA(1)==AND||LA(1)==MULT||LA(1)==DIVIDE)) {
					{
					switch ( LA(1)) {
					case MULT:
					{
						AST tmp247_AST = null;
						tmp247_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp247_AST);
						match(MULT);
						break;
					}
					case DIVIDE:
					{
						AST tmp248_AST = null;
						tmp248_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp248_AST);
						match(DIVIDE);
						break;
					}
					case AND:
					{
						AST tmp249_AST = null;
						tmp249_AST = astFactory.create(LT(1));
						astFactory.makeASTRoot(currentAST, tmp249_AST);
						match(AND);
						break;
					}
					default:
					{
						throw new NoViableAltException(LT(1), getFilename());
					}
					}
					}
					signedFactor();
					astFactory.addASTChild(currentAST, returnAST);
				}
				else {
					break _loop203;
				}
				
			} while (true);
			}
			term_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_34);
			} else {
			  throw ex;
			}
		}
		returnAST = term_AST;
	}
	
	public final void signedFactor() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST signedFactor_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case FALSE:
			case NEW:
			case NULL_STATEMENT:
			case TRUE:
			case IDENTIFIER:
			case OPEN_PAR:
			case OPEN_BRACKET:
			case PLUS:
			case MINUS:
			case INTEGER:
			{
				{
				switch ( LA(1)) {
				case PLUS:
				{
					AST tmp250_AST = null;
					tmp250_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp250_AST);
					match(PLUS);
					break;
				}
				case MINUS:
				{
					AST tmp251_AST = null;
					tmp251_AST = astFactory.create(LT(1));
					astFactory.makeASTRoot(currentAST, tmp251_AST);
					match(MINUS);
					break;
				}
				case FALSE:
				case NEW:
				case NULL_STATEMENT:
				case TRUE:
				case IDENTIFIER:
				case OPEN_PAR:
				case OPEN_BRACKET:
				case INTEGER:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				factor();
				astFactory.addASTChild(currentAST, returnAST);
				signedFactor_AST = (AST)currentAST.root;
				break;
			}
			case NOT:
			{
				AST tmp252_AST = null;
				tmp252_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp252_AST);
				match(NOT);
				factor();
				astFactory.addASTChild(currentAST, returnAST);
				signedFactor_AST = (AST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_26);
			} else {
			  throw ex;
			}
		}
		returnAST = signedFactor_AST;
	}
	
	public final void factor() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST factor_AST = null;
		
		try {      // for error handling
			switch ( LA(1)) {
			case INTEGER:
			{
				AST tmp253_AST = null;
				tmp253_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp253_AST);
				match(INTEGER);
				factor_AST = (AST)currentAST.root;
				break;
			}
			case OPEN_PAR:
			{
				AST tmp254_AST = null;
				tmp254_AST = astFactory.create(LT(1));
				astFactory.makeASTRoot(currentAST, tmp254_AST);
				match(OPEN_PAR);
				expression();
				astFactory.addASTChild(currentAST, returnAST);
				match(CLOSE_PAR);
				factor_AST = (AST)currentAST.root;
				break;
			}
			case TRUE:
			{
				AST tmp256_AST = null;
				tmp256_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp256_AST);
				match(TRUE);
				factor_AST = (AST)currentAST.root;
				break;
			}
			case FALSE:
			{
				AST tmp257_AST = null;
				tmp257_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp257_AST);
				match(FALSE);
				factor_AST = (AST)currentAST.root;
				break;
			}
			case NULL_STATEMENT:
			{
				AST tmp258_AST = null;
				tmp258_AST = astFactory.create(LT(1));
				astFactory.addASTChild(currentAST, tmp258_AST);
				match(NULL_STATEMENT);
				factor_AST = (AST)currentAST.root;
				break;
			}
			case NEW:
			{
				dynamic_instanciation();
				astFactory.addASTChild(currentAST, returnAST);
				factor_AST = (AST)currentAST.root;
				break;
			}
			default:
				boolean synPredMatched208 = false;
				if (((LA(1)==IDENTIFIER) && (LA(2)==OPEN_PAR||LA(2)==EXT_CALL||LA(2)==DOT) && (_tokenSet_13.member(LA(3))))) {
					int _m208 = mark();
					synPredMatched208 = true;
					inputState.guessing++;
					try {
						{
						variable_occurence();
						match(EXT_CALL);
						}
					}
					catch (RecognitionException pe) {
						synPredMatched208 = false;
					}
					rewind(_m208);
					inputState.guessing--;
				}
				if ( synPredMatched208 ) {
					external_call();
					astFactory.addASTChild(currentAST, returnAST);
					factor_AST = (AST)currentAST.root;
				}
				else {
					boolean synPredMatched215 = false;
					if (((LA(1)==IDENTIFIER||LA(1)==OPEN_BRACKET) && (_tokenSet_16.member(LA(2))) && (_tokenSet_15.member(LA(3))))) {
						int _m215 = mark();
						synPredMatched215 = true;
						inputState.guessing++;
						try {
							{
							{
							switch ( LA(1)) {
							case OPEN_BRACKET:
							{
								discriminant();
								break;
							}
							case IDENTIFIER:
							{
								break;
							}
							default:
							{
								throw new NoViableAltException(LT(1), getFilename());
							}
							}
							}
							{
							if ((LA(1)==IDENTIFIER) && (LA(2)==COLON)) {
								match(IDENTIFIER);
								match(COLON);
							}
							else if ((LA(1)==IDENTIFIER) && (LA(2)==OPEN_PAR)) {
							}
							else {
								throw new NoViableAltException(LT(1), getFilename());
							}
							
							}
							match(IDENTIFIER);
							match(OPEN_PAR);
							{
							switch ( LA(1)) {
							case FALSE:
							case NOT:
							case NEW:
							case NULL_STATEMENT:
							case TRUE:
							case IDENTIFIER:
							case OPEN_PAR:
							case OPEN_BRACKET:
							case PLUS:
							case MINUS:
							case INTEGER:
							{
								expression();
								{
								_loop214:
								do {
									if ((LA(1)==COMA)) {
										match(COMA);
										expression();
									}
									else {
										break _loop214;
									}
									
								} while (true);
								}
								break;
							}
							case CLOSE_PAR:
							{
								break;
							}
							default:
							{
								throw new NoViableAltException(LT(1), getFilename());
							}
							}
							}
							match(CLOSE_PAR);
							match(EQUIV);
							}
						}
						catch (RecognitionException pe) {
							synPredMatched215 = false;
						}
						rewind(_m215);
						inputState.guessing--;
					}
					if ( synPredMatched215 ) {
						function_call();
						astFactory.addASTChild(currentAST, returnAST);
						factor_AST = (AST)currentAST.root;
					}
					else {
						boolean synPredMatched217 = false;
						if (((LA(1)==IDENTIFIER) && (_tokenSet_35.member(LA(2))) && (_tokenSet_36.member(LA(3))))) {
							int _m217 = mark();
							synPredMatched217 = true;
							inputState.guessing++;
							try {
								{
								variable_occurence();
								}
							}
							catch (RecognitionException pe) {
								synPredMatched217 = false;
							}
							rewind(_m217);
							inputState.guessing--;
						}
						if ( synPredMatched217 ) {
							variable_occurence();
							astFactory.addASTChild(currentAST, returnAST);
							factor_AST = (AST)currentAST.root;
						}
					else {
						throw new NoViableAltException(LT(1), getFilename());
					}
					}}}
				}
				catch (RecognitionException ex) {
					if (inputState.guessing==0) {
						reportError(ex);
						consume();
						consumeUntil(_tokenSet_26);
					} else {
					  throw ex;
					}
				}
				returnAST = factor_AST;
			}
			
	public final void dynamic_instanciation() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST dynamic_instanciation_AST = null;
		
		try {      // for error handling
			AST tmp259_AST = null;
			tmp259_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp259_AST);
			match(NEW);
			AST tmp260_AST = null;
			tmp260_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp260_AST);
			match(IDENTIFIER);
			AST tmp261_AST = null;
			tmp261_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp261_AST);
			match(OPEN_PAR);
			{
			switch ( LA(1)) {
			case IDENTIFIER:
			{
				agregate_element();
				astFactory.addASTChild(currentAST, returnAST);
				{
				_loop229:
				do {
					if ((LA(1)==COMA)) {
						AST tmp262_AST = null;
						tmp262_AST = astFactory.create(LT(1));
						astFactory.addASTChild(currentAST, tmp262_AST);
						match(COMA);
						agregate_element();
						astFactory.addASTChild(currentAST, returnAST);
					}
					else {
						break _loop229;
					}
					
				} while (true);
				}
				break;
			}
			case CLOSE_PAR:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			AST tmp263_AST = null;
			tmp263_AST = astFactory.create(LT(1));
			astFactory.addASTChild(currentAST, tmp263_AST);
			match(CLOSE_PAR);
			dynamic_instanciation_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_26);
			} else {
			  throw ex;
			}
		}
		returnAST = dynamic_instanciation_AST;
	}
	
	public final void atomic_variable() throws RecognitionException, TokenStreamException {
		
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		AST atomic_variable_AST = null;
		
		try {      // for error handling
			AST tmp264_AST = null;
			tmp264_AST = astFactory.create(LT(1));
			astFactory.makeASTRoot(currentAST, tmp264_AST);
			match(IDENTIFIER);
			{
			switch ( LA(1)) {
			case OPEN_PAR:
			{
				match(OPEN_PAR);
				{
				switch ( LA(1)) {
				case FALSE:
				case NOT:
				case NEW:
				case NULL_STATEMENT:
				case TRUE:
				case IDENTIFIER:
				case OPEN_PAR:
				case OPEN_BRACKET:
				case PLUS:
				case MINUS:
				case INTEGER:
				{
					expression();
					astFactory.addASTChild(currentAST, returnAST);
					{
					_loop225:
					do {
						if ((LA(1)==COMA)) {
							AST tmp266_AST = null;
							tmp266_AST = astFactory.create(LT(1));
							astFactory.addASTChild(currentAST, tmp266_AST);
							match(COMA);
							expression();
							astFactory.addASTChild(currentAST, returnAST);
						}
						else {
							break _loop225;
						}
						
					} while (true);
					}
					break;
				}
				case CLOSE_PAR:
				{
					break;
				}
				default:
				{
					throw new NoViableAltException(LT(1), getFilename());
				}
				}
				}
				match(CLOSE_PAR);
				break;
			}
			case AND:
			case BEGIN:
			case END:
			case IS:
			case OF:
			case OR:
			case THEN:
			case WITH:
			case IDENTIFIER:
			case COMA:
			case SEMI_COLON:
			case AFFECT:
			case CLOSE_PAR:
			case EXT_CALL:
			case DOT:
			case RANGE_OP:
			case CLOSE_BRACKET:
			case EQUAL:
			case DIFF:
			case LESS:
			case LESS_EQ:
			case GREATER:
			case GREATER_EQ:
			case PLUS:
			case MINUS:
			case MULT:
			case DIVIDE:
			{
				break;
			}
			default:
			{
				throw new NoViableAltException(LT(1), getFilename());
			}
			}
			}
			atomic_variable_AST = (AST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				consume();
				consumeUntil(_tokenSet_37);
			} else {
			  throw ex;
			}
		}
		returnAST = atomic_variable_AST;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"\"accept\"",
		"\"and\"",
		"\"array\"",
		"\"asynchronous\"",
		"BAG",
		"\"begin\"",
		"\"binder\"",
		"\"break\"",
		"\"channel\"",
		"\"circular\"",
		"\"class\"",
		"\"const\"",
		"\"declare\"",
		"\"else\"",
		"\"elsif\"",
		"\"end\"",
		"\"enum\"",
		"\"false\"",
		"FIELD",
		"\"fifo\"",
		"\"for\"",
		"\"function\"",
		"\"goto\"",
		"\"if\"",
		"\"in\"",
		"\"inout\"",
		"\"is\"",
		"LABEL",
		"\"not\"",
		"\"media\"",
		"\"new\"",
		"\"null\"",
		"\"of\"",
		"\"opaque\"",
		"\"or\"",
		"\"out\"",
		"\"port\"",
		"\"procedure\"",
		"\"range\"",
		"\"record\"",
		"\"return\"",
		"ROOT",
		"\"static\"",
		"\"synchronous\"",
		"\"set\"",
		"\"then\"",
		"\"this\"",
		"\"trigger\"",
		"\"true\"",
		"\"type\"",
		"VARIABLE",
		"\"while\"",
		"\"with\"",
		"UNARY_MINUS",
		"EXPR_EXT_CALL",
		"EXT_METHOD_NAME",
		"NULL_EXPRESSION",
		"TYPE_ATTRIBUTE",
		"DECLARATION_IDENTIFIER",
		"IDENTIFIER",
		"COMA",
		"COLON",
		"SEMI_COLON",
		"AFFECT",
		"OPEN_PAR",
		"CLOSE_PAR",
		"RIGHT_ARROW",
		"EXT_CALL",
		"LEFT_ARROW",
		"DOT",
		"CAN_READ",
		"CAN_WRITE",
		"RANGE_OP",
		"ARROW",
		"EQUIV",
		"OPEN_BRACKET",
		"CLOSE_BRACKET",
		"EQUAL",
		"DIFF",
		"LESS",
		"LESS_EQ",
		"GREATER",
		"GREATER_EQ",
		"QUOTE",
		"PLUS",
		"MINUS",
		"MULT",
		"DIVIDE",
		"INTEGER",
		"IMPLIES",
		"NL",
		"WS",
		"COMMENT"
	};
	
	protected void buildTokenTypeASTClassMap() {
		tokenTypeToASTClassMap=null;
	};
	
	private static final long[] mk_tokenSet_0() {
		long[] data = { 2L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_0 = new BitSet(mk_tokenSet_0());
	private static final long[] mk_tokenSet_1() {
		long[] data = { -9211899723906496894L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_1 = new BitSet(mk_tokenSet_1());
	private static final long[] mk_tokenSet_2() {
		long[] data = { -9214294460265872382L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_2 = new BitSet(mk_tokenSet_2());
	private static final long[] mk_tokenSet_3() {
		long[] data = { -9212113037786316800L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_3 = new BitSet(mk_tokenSet_3());
	private static final long[] mk_tokenSet_4() {
		long[] data = { -9211970101241151360L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_4 = new BitSet(mk_tokenSet_4());
	private static final long[] mk_tokenSet_5() {
		long[] data = { -9212113037785792000L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_5 = new BitSet(mk_tokenSet_5());
	private static final long[] mk_tokenSet_6() {
		long[] data = { -9187325613071857648L, 32786L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_6 = new BitSet(mk_tokenSet_6());
	private static final long[] mk_tokenSet_7() {
		long[] data = { 0L, 4L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_7 = new BitSet(mk_tokenSet_7());
	private static final long[] mk_tokenSet_8() {
		long[] data = { -9223372036854775808L, 33L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_8 = new BitSet(mk_tokenSet_8());
	private static final long[] mk_tokenSet_9() {
		long[] data = { -9211970101240626560L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_9 = new BitSet(mk_tokenSet_9());
	private static final long[] mk_tokenSet_10() {
		long[] data = { -9211970101240626558L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_10 = new BitSet(mk_tokenSet_10());
	private static final long[] mk_tokenSet_11() {
		long[] data = { -9218868381390733312L, 318799888L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_11 = new BitSet(mk_tokenSet_11());
	private static final long[] mk_tokenSet_12() {
		long[] data = { -9182839309493861856L, 536773266L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_12 = new BitSet(mk_tokenSet_12());
	private static final long[] mk_tokenSet_13() {
		long[] data = { -9218868381390733312L, 318799920L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_13 = new BitSet(mk_tokenSet_13());
	private static final long[] mk_tokenSet_14() {
		long[] data = { -9187325613071857648L, 32787L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_14 = new BitSet(mk_tokenSet_14());
	private static final long[] mk_tokenSet_15() {
		long[] data = { -9218868106512826336L, 536838835L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_15 = new BitSet(mk_tokenSet_15());
	private static final long[] mk_tokenSet_16() {
		long[] data = { -9218868381390733312L, 318799890L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_16 = new BitSet(mk_tokenSet_16());
	private static final long[] mk_tokenSet_17() {
		long[] data = { -9187325613070940144L, 32786L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_17 = new BitSet(mk_tokenSet_17());
	private static final long[] mk_tokenSet_18() {
		long[] data = { 68719477248L, 33L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_18 = new BitSet(mk_tokenSet_18());
	private static final long[] mk_tokenSet_19() {
		long[] data = { 2199057334272L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_19 = new BitSet(mk_tokenSet_19());
	private static final long[] mk_tokenSet_20() {
		long[] data = { -9223372036854251520L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_20 = new BitSet(mk_tokenSet_20());
	private static final long[] mk_tokenSet_21() {
		long[] data = { 0L, 32L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_21 = new BitSet(mk_tokenSet_21());
	private static final long[] mk_tokenSet_22() {
		long[] data = { -9218305086766185952L, 528454327L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_22 = new BitSet(mk_tokenSet_22());
	private static final long[] mk_tokenSet_23() {
		long[] data = { -9222809017108135424L, 69669L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_23 = new BitSet(mk_tokenSet_23());
	private static final long[] mk_tokenSet_24() {
		long[] data = { 0L, 36L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_24 = new BitSet(mk_tokenSet_24());
	private static final long[] mk_tokenSet_25() {
		long[] data = { -9150751148191776224L, 259985581L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_25 = new BitSet(mk_tokenSet_25());
	private static final long[] mk_tokenSet_26() {
		long[] data = { -9222808742230228448L, 259985445L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_26 = new BitSet(mk_tokenSet_26());
	private static final long[] mk_tokenSet_27() {
		long[] data = { -9223372036854775808L, 16L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_27 = new BitSet(mk_tokenSet_27());
	private static final long[] mk_tokenSet_28() {
		long[] data = { 524288L, 5L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_28 = new BitSet(mk_tokenSet_28());
	private static final long[] mk_tokenSet_29() {
		long[] data = { 917504L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_29 = new BitSet(mk_tokenSet_29());
	private static final long[] mk_tokenSet_30() {
		long[] data = { -9223372036854775808L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_30 = new BitSet(mk_tokenSet_30());
	private static final long[] mk_tokenSet_31() {
		long[] data = { 524288L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_31 = new BitSet(mk_tokenSet_31());
	private static final long[] mk_tokenSet_32() {
		long[] data = { 0L, 37L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_32 = new BitSet(mk_tokenSet_32());
	private static final long[] mk_tokenSet_33() {
		long[] data = { -9222809017108135424L, 8327205L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_33 = new BitSet(mk_tokenSet_33());
	private static final long[] mk_tokenSet_34() {
		long[] data = { -9222808742230228480L, 58658853L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_34 = new BitSet(mk_tokenSet_34());
	private static final long[] mk_tokenSet_35() {
		long[] data = { -9222808742230228448L, 259985973L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_35 = new BitSet(mk_tokenSet_35());
	private static final long[] mk_tokenSet_36() {
		long[] data = { -9098728790356406606L, 1065350143L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_36 = new BitSet(mk_tokenSet_36());
	private static final long[] mk_tokenSet_37() {
		long[] data = { -9150751148191776224L, 259986093L, 0L, 0L};
		return data;
	}
	public static final BitSet _tokenSet_37 = new BitSet(mk_tokenSet_37());
	
	}
